> ## Documentation Index
> Fetch the complete documentation index at: https://www.qovery.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List environment deployments

> List previous and current environment deployments with the status deployment and the related services. By default it returns the 20 last results. The response is paginated. In order to request the next page, you can use the startId query parameter



## OpenAPI

````yaml /api-reference/openapi.yaml get /environment/{environmentId}/deploymentHistoryV2
openapi: 3.0.0
info:
  version: 1.0.4
  title: Qovery API
  description: >
    - Qovery is the fastest way to deploy your full-stack apps on any Cloud
    provider.

    - ℹ️ The API is stable and still in development.
  contact:
    name: Qovery Product Team
    url: https://www.qovery.com
    email: support+api+documentation@qovery.com
  x-logo:
    url: https://console.qovery.com/assets/logos/logo-white.svg
    altText: Qovery
servers:
  - url: https://api.qovery.com
security:
  - bearerAuth: []
  - ApiKeyAuth: []
tags:
  - name: Account
  - name: Account Info
  - name: Alert Receivers
  - name: Alert Rules
  - name: Admin
  - name: ArgoCD
  - name: Application
  - name: Application Actions
  - name: Application Configuration
  - name: Application Database
  - name: Application Deployment Restriction
  - name: Application Deployment History
  - name: Application Environment Variable
  - name: Application Logs
  - name: Application Main Calls
  - name: Application Secret
  - name: Application Annotations Group
  - name: Applications
  - name: AutoscalingPolicy
  - name: Container
  - name: Container Actions
  - name: Container Configuration
  - name: Container Database
  - name: Container Deployment History
  - name: Container Environment Variable
  - name: Container Logs
  - name: Container Main Calls
  - name: Container Registry
  - name: Container Secret
  - name: Container Annotations Group
  - name: Containers
  - name: Deployment Stage Main Calls
  - name: Job
  - name: Job Actions
  - name: Job Configuration
  - name: Job Database
  - name: Job Deployment Restriction
  - name: Job Deployment History
  - name: Job Environment Variable
  - name: Job Logs
  - name: Job Main Calls
  - name: Job Registry
  - name: Job Secret
  - name: Job Annotations Group
  - name: Jobs
  - name: KedaTriggerAuthentication
  - name: Helm
  - name: Helm Actions
  - name: Helm Configuration
  - name: Helm Database
  - name: Helm Deployment Restriction
  - name: Helm Deployment History
  - name: Helm Logs
  - name: Helm Main Calls
  - name: Helm Repository
  - name: Helms
  - name: Backups
  - name: Billing
  - name: Cloud Provider
  - name: Cloud Provider Credentials
  - name: Clusters
  - name: Custom Domain
  - name: Container Custom Domain
  - name: Database
  - name: Database Actions
  - name: Database Application
  - name: Database Container
  - name: Database Deployment History
  - name: Database Main Calls
  - name: Database Annotations Group
  - name: Databases
  - name: Environment
  - name: Environment Actions
  - name: Environment Deployment History
  - name: Environment Deployment Rule
  - name: Environment Logs
  - name: Environment Main Calls
  - name: Environment Secret
  - name: Environment Variable
  - name: Environments
  - name: Git
  - name: Github App
  - name: Git repositories
  - name: Members
  - name: Organization
  - name: Organization Account Git Repositories
  - name: Organization Cluster Lock
  - name: Organization Main Calls
  - name: Organization Custom Role
  - name: Organization Event
  - name: Organization Api Token
  - name: Organization Webhook
  - name: Organization Annotations Group
  - name: Organization Labels Group
  - name: Organization Enterprise Connection
  - name: Project
  - name: Project Deployment Rule
  - name: Project Environment Variable
  - name: Project Main Calls
  - name: Project Secret
  - name: Projects
  - name: Referral & Rewards
  - name: Secret Manager Access
  - name: Terraforms
  - name: Terraform Main Calls
  - name: Terraform Resources
  - name: Terraform Deployment History
  - name: Terraform Deployment Restriction
  - name: Container Registries
  - name: Helm Repositories
  - name: User Sign Up
  - name: Variable Main Calls
  - name: Helm Custom Domain
  - name: Lifecycle Template Main Calls
paths:
  /environment/{environmentId}/deploymentHistoryV2:
    parameters:
      - schema:
          type: string
          format: uuid
        name: environmentId
        in: path
        required: true
    get:
      tags:
        - Environment Deployment History
      summary: List environment deployments
      description: >-
        List previous and current environment deployments with the status
        deployment and the related services. By default it returns the 20 last
        results. The response is paginated. In order to request the next page,
        you can use the startId query parameter
      operationId: listEnvironmentDeploymentHistoryV2
      parameters:
        - in: query
          name: pageSize
          description: The number of deployments to return in the current page
          schema:
            type: number
            nullable: true
            default: 20
      responses:
        '200':
          description: List deployment history
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/DeploymentHistoryEnvironmentPaginatedResponseListV2
        '401':
          $ref: '#/components/responses/401'
        '403':
          $ref: '#/components/responses/403'
        '404':
          $ref: '#/components/responses/404'
components:
  schemas:
    DeploymentHistoryEnvironmentPaginatedResponseListV2:
      allOf:
        - $ref: '#/components/schemas/PaginationData'
        - type: object
          properties:
            results:
              type: array
              items:
                $ref: '#/components/schemas/DeploymentHistoryEnvironmentV2'
      x-stoplight:
        id: 0anfgzdi689ht
    PaginationData:
      type: object
      required:
        - page
        - page_size
      properties:
        page:
          type: number
          example: 1
        page_size:
          type: number
          example: 20
    DeploymentHistoryEnvironmentV2:
      x-stoplight:
        id: j6o3qzzhhu0me
      type: object
      required:
        - identifier
        - auditing_data
        - status
        - trigger_action
        - total_duration
        - stages
        - action_status
      properties:
        identifier:
          type: object
          x-stoplight:
            id: cpv6dbyt9dng2
          required:
            - execution_id
            - environment_id
          properties:
            execution_id:
              type: string
              x-stoplight:
                id: 6psngtbgz1bub
            environment_id:
              type: string
              x-stoplight:
                id: 6o54s8cbk0lo6
              format: uuid
        auditing_data:
          $ref: '#/components/schemas/DeploymentHistoryAuditingData'
        status:
          $ref: '#/components/schemas/StateEnum'
        trigger_action:
          $ref: '#/components/schemas/DeploymentHistoryTriggerAction'
        total_duration:
          type: string
          x-stoplight:
            id: 3qptomnr4oly4
          format: duration
        stages:
          type: array
          x-stoplight:
            id: rz2b0h9r3p6tv
          items:
            $ref: '#/components/schemas/DeploymentHistoryStage'
        action_status:
          $ref: '#/components/schemas/DeploymentHistoryActionStatus'
    DeploymentHistoryAuditingData:
      x-stoplight:
        id: 5oovmby4u1mxw
      type: object
      required:
        - created_at
        - updated_at
        - triggered_by
      properties:
        created_at:
          type: string
          x-stoplight:
            id: e1idlr92680lb
          format: date-time
        updated_at:
          type: string
          x-stoplight:
            id: mz8yet1k3voef
          format: date-time
        triggered_by:
          type: string
          x-stoplight:
            id: hf405wx2g73py
        origin:
          $ref: '#/components/schemas/OrganizationEventOrigin'
    StateEnum:
      type: string
      enum:
        - BUILDING
        - BUILD_ERROR
        - CANCELED
        - CANCELING
        - DELETED
        - DELETE_ERROR
        - DELETE_QUEUED
        - DELETING
        - DEPLOYED
        - DEPLOYING
        - DEPLOYMENT_ERROR
        - DEPLOYMENT_QUEUED
        - EXECUTING
        - QUEUED
        - READY
        - RECAP
        - RESTARTED
        - RESTARTING
        - RESTART_ERROR
        - RESTART_QUEUED
        - STOPPED
        - STOPPING
        - STOP_ERROR
        - STOP_QUEUED
        - UNAVAILABLE
        - WAITING_DELETING
        - WAITING_RESTARTING
        - WAITING_RUNNING
        - WAITING_STOPPING
    DeploymentHistoryTriggerAction:
      x-stoplight:
        id: 1hzy6riqo7lq4
      enum:
        - DEPLOY
        - DELETE
        - RESTART
        - STOP
        - DEPLOY_DRY_RUN
        - TERRAFORM_FORCE_UNLOCK
        - TERRAFORM_MIGRATE_STATE
        - DELETE_RESOURCES_ONLY
        - UNKNOWN
        - UNINSTALL
    DeploymentHistoryStage:
      type: object
      x-stoplight:
        id: crvf2cbwrvxyh
      required:
        - name
        - status
        - duration
        - services
      properties:
        name:
          type: string
          x-stoplight:
            id: e1fv4x2xo0wo0
        status:
          $ref: '#/components/schemas/StageStatusEnum'
        duration:
          type: string
          x-stoplight:
            id: mdqlsz36jtl4j
          format: duration
        services:
          type: array
          x-stoplight:
            id: sel4jtb8tbjwz
          items:
            $ref: '#/components/schemas/DeploymentHistoryService'
    DeploymentHistoryActionStatus:
      title: DeploymentHistoryActionStatus
      x-stoplight:
        id: qppeluzk1hor1
      enum:
        - QUEUED
        - ONGOING
        - SUCCESS
        - ERROR
        - CANCELED
        - CANCELING
        - NEVER
    OrganizationEventOrigin:
      type: string
      description: Origin of the organization event
      enum:
        - API
        - CLI
        - CONSOLE
        - GIT
        - QOVERY_INTERNAL
        - TERRAFORM_PROVIDER
      example: API
    StageStatusEnum:
      type: string
      x-stoplight:
        id: lv5pyjmui11rn
      enum:
        - QUEUED
        - ONGOING
        - DONE
        - ERROR
        - SKIPPED
        - CANCELED
    DeploymentHistoryService:
      type: object
      x-stoplight:
        id: 316ilxlmws82a
      required:
        - identifier
        - status
        - auditing_data
        - details
        - icon_uri
        - status_details
      properties:
        identifier:
          type: object
          x-stoplight:
            id: yklp44eea5vaq
          required:
            - name
            - service_id
            - service_type
          properties:
            name:
              type: string
              x-stoplight:
                id: h0xxiocxiusqw
            service_id:
              type: string
              x-stoplight:
                id: 0hb95ufaj9z82
              format: uuid
            service_type:
              $ref: '#/components/schemas/ServiceTypeEnum'
            execution_id:
              type: string
              x-stoplight:
                id: 9ww6nh5lrwg37
        status:
          $ref: '#/components/schemas/StateEnum'
        auditing_data:
          $ref: '#/components/schemas/DeploymentHistoryAuditingData'
        details:
          $ref: '#/components/schemas/DeploymentHistoryServiceDetails'
        status_details:
          $ref: '#/components/schemas/StatusDetails'
        icon_uri:
          type: string
          x-stoplight:
            id: 3418v53rx3mn9
          format: uri
        total_duration:
          type: string
          x-stoplight:
            id: adofwhd0bgwuw
          format: duration
    ServiceTypeEnum:
      type: string
      x-stoplight:
        id: d66063cd29913
      description: type of the service (application, database, job, ...)
      enum:
        - APPLICATION
        - DATABASE
        - CONTAINER
        - JOB
        - HELM
        - TERRAFORM
        - ARGOCD_APP
    DeploymentHistoryServiceDetails:
      x-stoplight:
        id: vx9hzryfyv7sb
      oneOf:
        - description: ApplicationDeploymentHistoryData
          type: object
          required:
            - commit
            - build_pod_name
          properties:
            commit:
              $ref: '#/components/schemas/Commit'
            build_pod_name:
              type: string
              description: >-
                The build pod name prefix for monitoring build runner usage.
                Format build-{execution_id}-0
        - description: ContainerDeploymentHistoryData
          type: object
          required:
            - image_name
            - tag
            - arguments
          properties:
            image_name:
              type: string
            tag:
              type: string
            arguments:
              type: array
              items:
                type: string
            entrypoint:
              type: string
        - description: JobDeploymentHistoryDetails
          type: object
          required:
            - image_name
            - tag
            - job_type
          properties:
            image_name:
              type: string
            tag:
              type: string
            commit:
              $ref: '#/components/schemas/Commit'
            schedule:
              type: object
              properties:
                on_start:
                  $ref: '#/components/schemas/JobLifecyleSchedule'
                on_stop:
                  $ref: '#/components/schemas/JobLifecyleSchedule'
                on_delete:
                  $ref: '#/components/schemas/JobLifecyleSchedule'
                cron_job:
                  $ref: '#/components/schemas/JobCronSchedule'
                lifecycle_type:
                  $ref: '#/components/schemas/JobLifecycleTypeEnum'
            job_type:
              x-stoplight:
                id: tz8apy1pqi9c5
              enum:
                - CRON
                - LIFECYCLE
            build_pod_name:
              type: string
              nullable: true
              description: >-
                The build pod name prefix. Only set for jobs with a git source
                (Docker build). Null for container-source jobs.
        - description: HelmDeploymentHistoryDetails
          type: object
          properties:
            commit:
              $ref: '#/components/schemas/Commit'
            repository:
              type: object
              properties:
                chart_name:
                  type: string
                chart_version:
                  type: string
      type: object
    StatusDetails:
      type: object
      required:
        - action
        - status
        - sub_action
      properties:
        action:
          $ref: '#/components/schemas/ServiceActionEnum'
        status:
          $ref: '#/components/schemas/ServiceActionStatusEnum'
        sub_action:
          $ref: '#/components/schemas/ServiceSubActionEnum'
    Commit:
      type: object
      nullable: true
      required:
        - git_commit_id
        - created_at
        - author_name
        - message
        - tag
      properties:
        created_at:
          type: string
          format: date-time
        git_commit_id:
          type: string
        tag:
          type: string
          example: v2.1.1
        message:
          type: string
        author_name:
          type: string
        author_avatar_url:
          type: string
        commit_page_url:
          type: string
    JobLifecyleSchedule:
      type: object
      x-stoplight:
        id: nbir5gxiux1ei
      required:
        - arguments
      properties:
        arguments:
          type: array
          x-stoplight:
            id: wj3fkami4h2b7
          items:
            x-stoplight:
              id: 4a4sqxpll8vlc
            type: string
        entrypoint:
          type: string
          x-stoplight:
            id: 951clotz2i2na
    JobCronSchedule:
      type: object
      x-stoplight:
        id: y5hby49m8v5zc
      required:
        - arguments
        - scheduled_at
        - timezone
      properties:
        arguments:
          type: array
          items:
            type: string
        entrypoint:
          type: string
        scheduled_at:
          type: string
          x-stoplight:
            id: a5x1s5kc53r1v
        timezone:
          type: string
          x-stoplight:
            id: btav5l3tp9w3l
    JobLifecycleTypeEnum:
      title: JobLifecycleTypeEnum
      x-stoplight:
        id: tz1t23a291l51
      enum:
        - GENERIC
        - TERRAFORM
        - CLOUDFORMATION
    ServiceActionEnum:
      type: string
      enum:
        - DEPLOY
        - DELETE
        - RESTART
        - STOP
        - UNKNOWN
    ServiceActionStatusEnum:
      type: string
      enum:
        - QUEUED
        - ONGOING
        - SUCCESS
        - ERROR
        - EXECUTING
        - CANCELED
        - CANCELING
        - NEVER
    ServiceSubActionEnum:
      type: string
      default: NONE
      enum:
        - NONE
        - TERRAFORM_PLAN_ONLY
        - TERRAFORM_PLAN_AND_APPLY
        - TERRAFORM_DESTROY
        - TERRAFORM_FORCE_UNLOCK_STATE
        - TERRAFORM_MIGRATE_STATE
  responses:
    '401':
      description: Access token is missing or invalid
    '403':
      description: Access forbidden
    '404':
      description: Resource not found
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >-
        JWT tokens should be used with OIDC account (human to machine). JWT
        tokens used by the Qovery console to communicate with the API have a
        TTL. Curl Example ' curl https://console.qovery.com/organization -H
        "Authorization: Bearer $qovery_token" '
    ApiKeyAuth:
      type: apiKey
      in: header
      name: Authorization
      description: >-
        Token API are generated by Qovery to manage machine to machine
        interaction and do not have a TTL. Curl Example ' curl
        https://console.qovery.com/organization -H "Authorization: Token
        $qovery_token" '

````